#include<iostream>
using namespace std;

// Deklaracje struktur:

// Ta struktura ma nazwe, ale nie definiuje swoich zmiennych.
// Zrobimy to pozniej i tak najczesciej sie robi
struct karta
{
    int figura;
    int kolor;
};	// Tu KONIECZNIE musi byc srednik

// Struktura moze nie miec nazwy, ale musi wtedy miec zdefiniowane zmienne.
struct
{
    char imie[50];
    char nazwisko[50];
} rozdajacy = {"Wielki", "Szu"}; // Lista definicji KONCZY sie SREDNIKiem

// Mozliwy jest rowniez wariant mieszany: podana nazwa I definicje zmiennych

// Prototypy funkcji uzytych w programie
// UWAGA!!! prototypy sa umieszczone PO deklaracjach struktur!!!
// W deklaracjach funkcji korzystamy ze struktury karta, podczas deklaracji
// funkcji kompilator musi juz znac deklaracje "karty"
void wypisz(karta k);
karta najnizsza();

int main()
{
// Definicje zmiennych
karta k1 = {2, 3}, k2;

    cout<<"Program ilustruje operacje na strukturach: "<<endl;
    
    // Odczytanie pola struktury
    cout<<"Dziesiejszym rozdajacym jest " << rozdajacy.imie <<
	" " << rozdajacy.nazwisko << endl << endl;

    cout<<"Zmodyfikujemy karte k2... "<<endl;
    // Wpisanie wartosci do pola struktury
    k2.figura = 14;
    k2.kolor = 4;
    
    // Wypiszmy wartosci kart k1 oraz k2
    cout<<"Karta k1:"<<endl;
    wypisz(k1);
    cout<<"Karta k2:"<<endl;
    wypisz(k2);
    cout<<endl;
    
    cout<<"Mozliwe sa przypisania struktur jako calosci..."<<endl;
    // Przypisanie jednej strukturze drugiej
    k2 = k1;

    cout<<"Karta k1:"<<endl;
    wypisz(k1);
    cout<<"Karta k2:"<<endl;
    wypisz(k2);
    cout<<endl;
    
    cout<<"Mozliwe jest przypisanie wyniku funkcji strukturze..."<<endl;
    // Przypisanie strukturze wyniku funkcji (musi zachodzic zgodnosc typow)
    k2 = najnizsza();    
    wypisz(k2);
    cout<<endl;
}

// funkcja moze przyjac strukture jako swoj parametr
void wypisz(karta k)
{
    if( (k.figura>=2) && (k.figura<=10)) cout<<k.figura<<" ";
    else
    switch(k.figura)
    {
	case 11:	cout<<"Walet ";
			break;
			
	case 12:	cout<<"Dama ";
			break;
		
	case 13:	cout<<"Krol ";
			break;
			
	case 14:	cout<<"As ";
			break;
	    
	default:	cout<<"Bledna karta (zla figura) ";
    }
    
    switch(k.kolor)
    {
	case 1:	cout<<"Pik"<<endl;
		break;
		
	case 2:	cout<<"Trefl"<<endl;
		break;
		
	case 3:	cout<<"Karo"<<endl;
		break;
		
	case 4:	cout<<"Kier"<<endl;
		break;
		
	default:cout<<"Bledna karta (zly kolor)"<<endl;
    }
}

// Funkcja moze zwrocic strukture
karta najnizsza()
{
karta wynik;
    
    wynik.kolor = 1;
    wynik.figura = 2;
    return wynik;
}
